package com.ruoyi.docking.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.annotation.DataSource;
import com.ruoyi.common.enums.DataSourceType;
import com.ruoyi.docking.entity.ProjectProgress;
import com.ruoyi.docking.mapper.ProjectMapper;
import com.ruoyi.docking.entity.Project;
import com.ruoyi.docking.service.ProjectService;
import org.springframework.stereotype.Service;

import java.time.ZoneId;
import java.time.ZonedDateTime;
import java.util.List;

/**
 * 项目（对接数据）(Project)表服务实现类
 *
 * @author makejava
 * @since 2025-03-25 14:47:59
 */
@Service("projectService")
public class ProjectServiceImpl extends ServiceImpl<ProjectMapper, Project> implements ProjectService {


    /**
     * 获取项目信息对接数据
     */
    @DataSource(value = DataSourceType.SLAVE)
    @Override
    public List<Project> djList() {
        //获取当前时间的上一个月的秒级时间戳
        // 获取当前时间（带时区）
        ZonedDateTime now = ZonedDateTime.now(ZoneId.systemDefault());
        // 计算上个月同一时间（自动处理跨月边界）
        ZonedDateTime lastMonth = now.minusMonths(1);
        // 上个月的时间转换为秒级时间戳
        long timestamp = lastMonth.toEpochSecond();
        // 当前的时间转换为秒级时间戳
        long nowTime = now.toEpochSecond();
        return lambdaQuery().ge(Project::getCreatedAt, timestamp)
                .lt(Project::getCreatedAt, nowTime).list();
    }
}

